"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/UserController.ts
const express_1 = require("express");
const User_1 = __importDefault(require("../Models/User"));
const Notifications_1 = __importDefault(require("../Models/Notifications"));
class MessageController {
    static async getNewNotifications(req, res) {
        try {
            const authHeader = req.headers.authorization; // or req.get('authorization')
            const user = await User_1.default.getByToken(authHeader);
            const messages = await Notifications_1.default.getNewNotifications(user.id);
            console.log(messages);
            await Notifications_1.default.markAsReceivedBulk(messages.map((m) => m.id));
            res.status(200).json(messages);
        }
        catch (error) {
            const err = error;
            console.log(err.message);
            res.status(500).json({ error: err.message });
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.get("/notifications", this.getNewNotifications);
        return router;
    }
}
exports.default = MessageController;
