"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/UserController.ts
const express_1 = require("express");
const Order_1 = __importDefault(require("../Models/Order"));
class OrdersAdminController {
    static async getOrders(req, res) {
        try {
            const page = req.query.page;
            const status = req.query.status;
            const p = page;
            const s = status;
            const users = await Order_1.default.get(parseInt(p || "1"), parseInt(s || "1"));
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static async updateStatus(req, res) {
        try {
            const { id, status, reson } = req.body;
            const users = await Order_1.default.updateStatus(id, status, reson);
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.get("/", this.getOrders);
        router.put("/", this.updateStatus);
        return router;
    }
}
exports.default = OrdersAdminController;
