"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/UserController.ts
const express_1 = require("express");
const upload_1 = __importDefault(require("../upload"));
const Order_1 = __importStar(require("../Models/Order"));
class OrdersController {
    static async get(req, res) {
        try {
            const page = req.query.page;
            const status = req.query.status;
            const id = req.params.id;
            const p = page;
            const s = status;
            const users = await Order_1.default.getOrdersForCustomer(id, parseInt(p || "1"), s ? parseInt(s || "1") : undefined);
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static async cancel(req, res) {
        try {
            const id = req.params.id;
            const users = await Order_1.default.updateStatus(id, Order_1.orderStatus.canceled);
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static async uploadNewInvoice(req, res) {
        try {
            const id = req.params.id;
            const invoice = req.file?.path;
            if (!invoice) {
                res.status(422).send("No Invoice");
                return;
            }
            const users = await Order_1.default.uploadNewInvoice(id, invoice);
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.get("/:id", this.get);
        router.get("/cancel/:id", this.cancel);
        router.put("/:id", upload_1.default.single("photo"), this.uploadNewInvoice);
        return router;
    }
}
exports.default = OrdersController;
