"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/LoginController.ts
const express_1 = require("express");
const Page_1 = __importDefault(require("../Models/Page"));
class PageController {
    static async get(req, res) {
        try {
            const data = await Page_1.default.getAll();
            res.json(data);
        }
        catch (error) {
            console.log(error);
            // @ts-ignore
            res.status(500).json({ error: error });
        }
    }
    static async create(req, res) {
        try {
            const { name, content } = req.body;
            await Page_1.default.create(name, content);
            res.status(201).send();
        }
        catch (error) {
            const err = error;
            console.log(err.message);
            // @ts-ignore
            res.status(500).json({ error: { message: err.message } });
        }
    }
    static async update(req, res) {
        try {
            const { name, content } = req.body;
            await Page_1.default.update(name, content);
            res.status(201).send();
        }
        catch (error) {
            const err = error;
            console.log(err.message);
            // @ts-ignore
            res.status(500).json({ error: { message: err.message } });
        }
    }
    static async delete(req, res) {
        try {
            const name = req.params.name;
            await Page_1.default.delete(name);
            res.status(201).send();
        }
        catch (error) {
            const err = error;
            console.log(err.message);
            // @ts-ignore
            res.status(500).json({ error: { message: err.message } });
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.get("/", this.get);
        router.post("/", this.create);
        router.put("/", this.update);
        router.delete("/:name", this.delete);
        return router;
    }
}
exports.default = PageController;
