"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/RequestsController.ts
const express_1 = require("express");
const User_1 = __importStar(require("../Models/User"));
const Notifications_1 = __importDefault(require("../Models/Notifications"));
class RequestsController {
    static async blockUser(req, res) {
        try {
            const id = req.params.id;
            const rides = await User_1.default.updateStatus(id, User_1.userstatus.blocked);
            res.json(rides);
        }
        catch (error) {
            console.error(error);
            res.status(500).send(error);
        }
    }
    static async approveUser(req, res) {
        try {
            const id = req.params.id;
            const rides = await User_1.default.updateStatus(id, User_1.userstatus.active);
            await Notifications_1.default.createNotification({ message: "قد تمت الموافقة على حسابك", title: "تحديث في الحساب", user_id: id });
            res.json(rides);
        }
        catch (error) {
            console.error(error);
            res.status(500).send(error);
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.get("/blockUser/:id", this.blockUser);
        router.get("/approveUser/:id", this.approveUser);
        return router;
    }
}
exports.default = RequestsController;
