"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/LoginController.ts
const express_1 = require("express");
const Settings_1 = __importDefault(require("../Models/Settings"));
class SettingsController {
    static async get(req, res) {
        try {
            const data = await Settings_1.default.getAll();
            res.json(data);
        }
        catch (error) {
            console.log(error);
            // @ts-ignore
            res.status(500).json({ error: error });
        }
    }
    static async store(req, res) {
        try {
            const { settings } = req.body;
            await Settings_1.default.Store(settings);
            res.status(201).send();
        }
        catch (error) {
            const err = error;
            console.log(err.message);
            // @ts-ignore
            res.status(500).json({ error: { message: err.message } });
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.post("/", this.store);
        router.get("/", this.get);
        return router;
    }
}
exports.default = SettingsController;
