"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// controllers/UserController.ts
const express_1 = require("express");
const User_1 = __importStar(require("../Models/User"));
const Analytic_1 = __importDefault(require("../Models/Analytic"));
const upload_1 = __importDefault(require("../upload"));
const Notifications_1 = __importDefault(require("../Models/Notifications"));
class UsersAdminController {
    static async create(req, res) {
        try {
            const { name, phone, password, type } = req.body;
            const profile_pic = req.file?.path;
            const service = await User_1.default.create(name, phone, password, type, profile_pic);
            res.status(201).json(service);
        }
        catch (error) {
            console.error(error);
            if (error === "username already used")
                res.status(422).send(error);
            else
                res.status(500).send("Internal Server Error");
        }
    }
    static async update(req, res) {
        try {
            const id = req.params.id;
            const { password, name, phone } = req.body;
            const profile_pic = req.file?.path;
            const user = await User_1.default.updateAdmin(id, password, name, phone, profile_pic);
            res.status(201).json(user);
        }
        catch (error) {
            console.error(error);
            res.status(500).send(error);
        }
    }
    static async updateType(req, res) {
        try {
            const id = req.params.id;
            const { type } = req.body;
            const user = await User_1.default.updateType(id, type);
            res.status(201).json(user);
        }
        catch (error) {
            console.error(error);
            res.status(500).send(error);
        }
    }
    static async logout(req, res) {
        try {
            const authHeader = req.headers.authorization || "";
            const token = authHeader.split(" ")[1];
            await User_1.default.logout(token);
            res.status(204).send();
        }
        catch (error) {
            console.log(error);
            // @ts-ignore
            res.status(500).json({ error: error.message });
        }
    }
    static async home(req, res) {
        try {
            const users = await User_1.default.getanalatics();
            const Analytics = await Analytic_1.default.getanalatics();
            res.json({ users, ...Analytics });
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static async get(req, res) {
        try {
            const page = req.query.page;
            const p = page;
            const type = req.query.type;
            console.log("we here");
            // @ts-ignore
            const users = await User_1.default.getusers(parseInt(p || "1"), type);
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static async search(req, res) {
        try {
            const keyword = req.params.keyword;
            const page = req.query.page;
            const p = page;
            const users = await User_1.default.search(keyword, parseInt(p || "1"));
            res.json(users);
        }
        catch (error) {
            console.error(error);
            res.status(500).send("Internal Server Error");
        }
    }
    static async delete(req, res) {
        try {
            const id = req.params.id;
            await User_1.default.delete(id);
            res.status(204).send(); // No content on successful deletion
        }
        catch (error) {
            console.error(error);
            res.status(500).json({ error: "Internal Server Error" });
        }
    }
    static async notfiy(req, res) {
        try {
            const user_id = req.query.user_id;
            const title = req.query.title;
            const message = req.query.message;
            if (user_id)
                await Notifications_1.default.createNotification({ message, title, user_id });
            else {
                let index = 0;
                let users = await User_1.default.getusers(1, User_1.userType.user);
                while (index < users.pages) {
                    index++;
                    const data = await User_1.default.getusers(index, User_1.userType.user);
                    await Promise.all(data.users.map(async (u) => {
                        try {
                            await Notifications_1.default.createNotification({ message, title, user_id: u.id });
                        }
                        catch (error) { }
                    }));
                }
            }
            res.status(201).send();
        }
        catch (error) {
            const err = error;
            console.log(err.message);
            // @ts-ignore
            res.status(500).json({ error: { message: err.message } });
        }
    }
    static getRouter() {
        const router = (0, express_1.Router)();
        router.post("/", upload_1.default.single("photo"), this.create);
        router.put("/:id", upload_1.default.single("photo"), this.update);
        router.put("/updateType/:id", this.updateType);
        router.get("/", this.get);
        router.get("/notfiy", this.notfiy);
        router.get("/home", this.home);
        router.get("/search/:keyword", this.search);
        router.get("/logout", this.logout);
        router.delete("/:id", this.delete);
        return router;
    }
}
exports.default = UsersAdminController;
