"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const DataBase_1 = __importDefault(require("../DataBase"));
const Snowflake_1 = __importDefault(require("../Snowflake"));
const Tabels_1 = require("../Constants/Tabels");
class Account {
    constructor(id, name, created_at, updated_at, number, bank) {
        this.name = name;
        this.id = id;
        this.created_at = created_at;
        this.updated_at = updated_at;
        this.bank = bank;
        this.number = number;
    }
    static async create(name, number, bank) {
        try {
            const id = Snowflake_1.default.nextId();
            await DataBase_1.default.create({ name, id, number, bank }, Tabels_1.ACCOUNT_TABLE);
            return id;
        }
        catch (error) {
            throw error;
        }
    }
    static async update(id, name, number, bank) {
        try {
            let model = { name, number, bank };
            await DataBase_1.default.update(id, model, Tabels_1.ACCOUNT_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
    static async get() {
        try {
            const vehicletypes = await DataBase_1.default.getAll(Tabels_1.ACCOUNT_TABLE);
            return vehicletypes;
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(id) {
        try {
            await DataBase_1.default.deleteById(id, Tabels_1.ACCOUNT_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = Account;
