"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const DataBase_1 = __importDefault(require("../DataBase"));
const Snowflake_1 = __importDefault(require("../Snowflake"));
const Tabels_1 = require("../Constants/Tabels");
const Product_1 = __importDefault(require("./Product"));
const Analytic_1 = __importDefault(require("./Analytic"));
class Cart {
    constructor(id, user_id, created_at, updated_at, product_id) {
        this.id = id;
        this.user_id = user_id;
        this.created_at = created_at;
        this.updated_at = updated_at;
        this.product_id = product_id;
    }
    static async create(user_id, product_id) {
        try {
            const id = Snowflake_1.default.nextId();
            await DataBase_1.default.create({ id, product_id, user_id }, Tabels_1.CART_TABLE);
            await Analytic_1.default.add("add_to_cart");
            return id;
        }
        catch (error) {
            throw error;
        }
    }
    static async get(user_id) {
        try {
            const Carts = await DataBase_1.default.getAll(Tabels_1.CART_TABLE, "*", "", "WHERE user_id = ?", [user_id]);
            const result = await Promise.all(Carts.map(async (cart) => {
                const product = await Product_1.default.getById(cart.product_id);
                return { ...cart, Product: product };
            }));
            return result;
        }
        catch (error) {
            throw error;
        }
    }
    static async deleteAll(id) {
        try {
            await DataBase_1.default.deleteByColumn(id, Tabels_1.CART_TABLE, "user_id");
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(id) {
        try {
            await DataBase_1.default.deleteById(id, Tabels_1.CART_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = Cart;
