"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const DataBase_1 = __importDefault(require("../DataBase"));
const Snowflake_1 = __importDefault(require("../Snowflake"));
const Tabels_1 = require("../Constants/Tabels");
class Category {
    constructor(id, name, created_at, updated_at, photo) {
        this.name = name;
        this.id = id;
        this.created_at = created_at;
        this.updated_at = updated_at;
        this.photo = photo;
    }
    static async create(name, photo) {
        try {
            const id = Snowflake_1.default.nextId();
            await DataBase_1.default.create({ name, id, photo }, Tabels_1.CATEGORY_TABLE);
            return id;
        }
        catch (error) {
            throw error;
        }
    }
    static async update(id, name, photo) {
        try {
            let model = { name };
            if (photo)
                model.photo = photo;
            await DataBase_1.default.update(id, model, Tabels_1.CATEGORY_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
    static async getById(id) {
        try {
            const Product = await DataBase_1.default.getById(id, Tabels_1.CATEGORY_TABLE);
            return Product;
        }
        catch (error) {
            throw error;
        }
    }
    static async search(keyword) {
        try {
            return await DataBase_1.default.getAll(Tabels_1.CATEGORY_TABLE, "*", "", "WHERE name LIKE ?", ["%" + keyword + "%"]);
        }
        catch (error) {
            throw error;
        }
    }
    static async getCategories() {
        try {
            const Categories = await DataBase_1.default.getAll(Tabels_1.CATEGORY_TABLE);
            return Categories;
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(id) {
        try {
            await DataBase_1.default.deleteById(id, Tabels_1.CATEGORY_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = Category;
