"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const DataBase_1 = __importDefault(require("../DataBase"));
const Snowflake_1 = __importDefault(require("../Snowflake"));
const Tabels_1 = require("../Constants/Tabels");
const Utils_1 = require("../Constants/Utils");
class Comments {
    constructor(id, user_id, created_at, updated_at, news_id, comment) {
        this.id = id;
        this.user_id = user_id;
        this.created_at = created_at;
        this.updated_at = updated_at;
        this.news_id = news_id;
        this.comment = comment;
    }
    static async create(user_id, news_id, comment) {
        try {
            const id = Snowflake_1.default.nextId();
            const comments = await DataBase_1.default.getAll(Tabels_1.COMMENTS_TABLE, "*", "", "WHERE user_id = ? AND news_id = ?", [user_id, news_id]);
            if (comments.length > 0)
                await DataBase_1.default.update(comments[0].id, { comment }, Tabels_1.COMMENTS_TABLE);
            else
                await DataBase_1.default.create({ id, news_id, comment, user_id }, Tabels_1.COMMENTS_TABLE);
            return id;
        }
        catch (error) {
            throw error;
        }
    }
    static async getById(id) {
        try {
            const Order = await DataBase_1.default.getById(id, Tabels_1.COMMENTS_TABLE);
            return Order;
        }
        catch (error) {
            throw error;
        }
    }
    static async getCommentsByNews(news_id) {
        try {
            const comments = await DataBase_1.default.getAll(Tabels_1.COMMENTS_TABLE, `${Tabels_1.COMMENTS_TABLE}.*, ${Tabels_1.USER_TABLE}.name as user_name, ${Tabels_1.USER_TABLE}.profile_pic as profile_pic`, `LEFT JOIN ${Tabels_1.USER_TABLE} ON ${Tabels_1.COMMENTS_TABLE}.user_id = ${Tabels_1.USER_TABLE}.id`, "WHERE news_id = ? LIMIT 3", [news_id]);
            const count = await DataBase_1.default.count(Tabels_1.COMMENTS_TABLE, "WHERE news_id = ?", [news_id]);
            return { comments, comments_count: count };
        }
        catch (error) {
            throw error;
        }
    }
    static async getAllCommentsByNews(news_id, page) {
        try {
            const Comments = await DataBase_1.default.paginate(page, Utils_1.PAGE_SIZE, Tabels_1.COMMENTS_TABLE, `${Tabels_1.COMMENTS_TABLE}.*, ${Tabels_1.USER_TABLE}.name as user_name, ${Tabels_1.USER_TABLE}.profile_pic as profile_pic`, `LEFT JOIN ${Tabels_1.USER_TABLE} ON ${Tabels_1.COMMENTS_TABLE}.user_id = ${Tabels_1.USER_TABLE}.id`, "WHERE news_id = ?", [news_id]);
            const count = await DataBase_1.default.count(Tabels_1.COMMENTS_TABLE, "WHERE news_id = ?", [news_id]);
            return { Comments, pages: Math.ceil(count / Utils_1.PAGE_SIZE) };
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(id) {
        try {
            await DataBase_1.default.deleteById(id, Tabels_1.COMMENTS_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = Comments;
