"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const DataBase_1 = __importDefault(require("../DataBase"));
const Snowflake_1 = __importDefault(require("../Snowflake"));
const Tabels_1 = require("../Constants/Tabels");
class OrderItem {
    constructor(id, order_id, created_at, updated_at, product_id, price_per_item, quantity, product_image, name) {
        this.id = id;
        this.order_id = order_id;
        this.created_at = created_at;
        this.updated_at = updated_at;
        this.product_id = product_id;
        this.product_image = product_image;
        this.name = name;
        this.price_per_item = price_per_item;
        this.quantity = quantity;
    }
    static async create(order_id, product_id, price_per_item, quantity) {
        try {
            const id = Snowflake_1.default.nextId();
            await DataBase_1.default.create({ id, product_id, price_per_item, quantity, order_id }, Tabels_1.ORDERS_ITEMS_TABLE);
            return id;
        }
        catch (error) {
            throw error;
        }
    }
    static async update(id, price_per_item, quantity) {
        try {
            await DataBase_1.default.update(id, { price_per_item, quantity }, Tabels_1.ORDERS_ITEMS_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
    static async getById(id) {
        try {
            const Order = await DataBase_1.default.getById(id, Tabels_1.ORDERS_ITEMS_TABLE);
            return Order;
        }
        catch (error) {
            throw error;
        }
    }
    static async getItemsByOrderId(order_id) {
        try {
            const Orders = await DataBase_1.default.getAll(Tabels_1.ORDERS_ITEMS_TABLE, `${Tabels_1.ORDERS_ITEMS_TABLE}.*, ${Tabels_1.PRODUCT_TABLE}.name, ${Tabels_1.PRODUCT_TABLE}.product_image`, `JOIN ${Tabels_1.PRODUCT_TABLE} ON ${Tabels_1.PRODUCT_TABLE}.id = ${Tabels_1.ORDERS_ITEMS_TABLE}.product_id`, "WHERE order_id = ?", [order_id]);
            return Orders;
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(id) {
        try {
            await DataBase_1.default.deleteById(id, Tabels_1.ORDERS_ITEMS_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = OrderItem;
