"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Tabels_1 = require("../Constants/Tabels");
const DataBase_1 = __importDefault(require("../DataBase"));
class Page {
    constructor(name, content) {
        this.name = name;
        this.content = content;
    }
    static async create(name, content) {
        try {
            await DataBase_1.default.create({ content, name }, Tabels_1.PAGE_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(name) {
        try {
            await DataBase_1.default.deleteByColumn(name, Tabels_1.PAGE_TABLE, "name");
        }
        catch (error) {
            throw error;
        }
    }
    static async update(name, content) {
        try {
            await DataBase_1.default.updateByColumn(name, "name", { content }, Tabels_1.PAGE_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
    static async getAll() {
        try {
            return await DataBase_1.default.getAll(Tabels_1.PAGE_TABLE);
        }
        catch (error) {
            throw error;
        }
    }
    static async getByname(name) {
        try {
            const setting = await DataBase_1.default.getByColumn(name, "name", Tabels_1.PAGE_TABLE);
            return setting.content;
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = Page;
