"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Tabels_1 = require("../Constants/Tabels");
const DataBase_1 = __importDefault(require("../DataBase"));
class Settings {
    constructor(name, value) {
        this.name = name;
        this.value = value;
    }
    static async Store(settings) {
        try {
            await Promise.all(settings.map(async (setting) => {
                const count = await DataBase_1.default.count(Tabels_1.SETTINGS_TABLE, "WHERE name = ?", [setting.name]);
                if (count > 0) {
                    await DataBase_1.default.updateByColumn(setting.name, "name", { value: setting.value }, Tabels_1.SETTINGS_TABLE);
                }
                else
                    await DataBase_1.default.create({ value: setting.value, name: setting.name }, Tabels_1.SETTINGS_TABLE);
            }));
        }
        catch (error) {
            throw error;
        }
    }
    static async getAll() {
        try {
            let seting = {};
            const Settings = await DataBase_1.default.getAll(Tabels_1.SETTINGS_TABLE);
            Settings.forEach((val) => {
                seting[val.name] = val.value;
            });
            return seting;
        }
        catch (error) {
            throw error;
        }
    }
    static async getByname(name) {
        try {
            const setting = await DataBase_1.default.getByColumn(name, "name", Tabels_1.SETTINGS_TABLE);
            return setting.value;
        }
        catch (error) {
            throw error;
        }
    }
    static async getBynameNumber(name) {
        try {
            const value = await this.getByname(name);
            return parseInt(value);
        }
        catch (error) {
            return;
        }
    }
}
exports.default = Settings;
