"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const DataBase_1 = __importDefault(require("../DataBase"));
const Snowflake_1 = __importDefault(require("../Snowflake"));
const Tabels_1 = require("../Constants/Tabels");
const Utils_1 = require("../Constants/Utils");
class Wishlist {
    constructor(id, user_id, created_at, updated_at, product_id) {
        this.id = id;
        this.user_id = user_id;
        this.created_at = created_at;
        this.updated_at = updated_at;
        this.product_id = product_id;
    }
    static async create(user_id, product_id) {
        try {
            const id = Snowflake_1.default.nextId();
            await DataBase_1.default.create({ id: id.toString(), product_id, user_id }, Tabels_1.WISHLIST_TABLE);
            return id;
        }
        catch (error) {
            throw error;
        }
    }
    static async getWishlists(user_id, page) {
        try {
            const Wishlists = await DataBase_1.default.paginate(page, Utils_1.PAGE_SIZE, Tabels_1.WISHLIST_TABLE, `${Tabels_1.PRODUCT_TABLE}.*, ${Tabels_1.CATEGORY_TABLE}.name as category_name, ${Tabels_1.CATEGORY_TABLE}.photo as category_photo`, `JOIN ${Tabels_1.PRODUCT_TABLE} ON ${Tabels_1.PRODUCT_TABLE}.id = ${Tabels_1.WISHLIST_TABLE}.product_id JOIN ${Tabels_1.CATEGORY_TABLE} ON ${Tabels_1.PRODUCT_TABLE}.Category_id = ${Tabels_1.CATEGORY_TABLE}.id`, `WHERE ${Tabels_1.WISHLIST_TABLE}.user_id = ?`, [user_id]);
            const count = await DataBase_1.default.count(Tabels_1.WISHLIST_TABLE);
            return { Wishlists, pages: Math.ceil(count / Utils_1.PAGE_SIZE) };
        }
        catch (error) {
            throw error;
        }
    }
    static async delete(user_id, product_id) {
        try {
            await DataBase_1.default.deleteComplex(Tabels_1.WISHLIST_TABLE, "WHERE user_id = ? AND product_id = ?", [user_id, product_id]);
        }
        catch (error) {
            throw error;
        }
    }
}
exports.default = Wishlist;
