"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.user = void 0;
exports.auth = auth;
exports.markSeen = markSeen;
exports.authAdmin = authAdmin;
const DataBase_1 = __importDefault(require("../DataBase"));
const User_1 = __importStar(require("../Models/User"));
const Tabels_1 = require("../Constants/Tabels");
const Analytic_1 = __importDefault(require("../Models/Analytic"));
async function auth(request, response, next) {
    // Log the request method and URL
    const authHeader = request.headers.authorization; // or req.get('authorization')
    if (authHeader) {
        const token = authHeader.split(" ")[1]; // get the token
        try {
            const rows = await DataBase_1.default.getAll("tokens t", "u.* ", `JOIN ${Tabels_1.USER_TABLE} u ON u.id = t.user_id`, "WHERE t.token = ?", [token]);
            const row = rows[0];
            if (row) {
                exports.user = row;
                if (row.status === User_1.userstatus.blocked)
                    return response.status(403).send(new Error("YOU ARE BLOCKED FROM SERVICE"));
                next();
            }
            else {
                // If no, send a 404 not found response
                response.status(401).send({ message: "wrong token" });
            }
        }
        catch (error) {
            return response.status(500).send(error.message);
        }
    }
    else {
        response.status(403).send({ message: "not authorize" });
        // handle the case when there is no authorization header
    }
    // Call the next function in the stack
}
async function markSeen(request, response, next) {
    try {
        const authHeader = request.headers.authorization; // or req.get('authorization')
        const user = await User_1.default.getByToken(authHeader);
        const today = new Date().toISOString().split("T")[0]; // Use a consistent date format
        if (user.last_seen !== today) {
            await User_1.default.updateLastseen(user.id);
            await Analytic_1.default.add("active_users");
        }
    }
    catch (error) {
    }
    finally {
        next();
    }
}
async function authAdmin(request, response, next) {
    // Log the request method and URL
    const authHeader = request.headers.authorization; // or req.get('authorization')
    if (authHeader) {
        const token = authHeader.split(" ")[1]; // get the token
        try {
            const rows = await DataBase_1.default.getAll("tokens t", "u.* ", `JOIN ${Tabels_1.USER_TABLE} u ON u.id = t.user_id`, "WHERE t.token = ?", [token]);
            const row = rows[0];
            if (!row)
                response.status(401).send({ message: "wrong token" });
            if (row.type == User_1.userType.admin) {
                exports.user = row;
                if (row.status === User_1.userstatus.blocked)
                    return response.status(403).send(new Error("YOU ARE BLOCKED FROM SERVICE"));
                next();
            }
            else {
                // If no, send a 404 not found response
                response.status(401).send({ message: "not AN Admin" });
            }
        }
        catch (error) {
            return response.status(500).send(error.message);
        }
    }
    else {
        response.status(403).send({ message: "not authorize" });
        // handle the case when there is no authorization header
    }
    // Call the next function in the stack
}
