"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const http_1 = __importDefault(require("http"));
const cors_1 = __importDefault(require("cors"));
const TopicAdminController_1 = __importDefault(require("./Controller/TopicAdminController"));
const UsersAdminController_1 = __importDefault(require("./Controller/UsersAdminController"));
const ProductsAdminController_1 = __importDefault(require("./Controller/ProductsAdminController"));
const CategoriesAdminController_1 = __importDefault(require("./Controller/CategoriesAdminController"));
const LoginController_1 = __importDefault(require("./Controller/LoginController"));
const UsersController_1 = __importDefault(require("./Controller/UsersController"));
const MessageController_1 = __importDefault(require("./Controller/MessageController"));
const OrdersController_1 = __importDefault(require("./Controller/OrdersController"));
const PublicController_1 = __importDefault(require("./Controller/PublicController"));
const CartController_1 = __importDefault(require("./Controller/CartController"));
const WishListController_1 = __importDefault(require("./Controller/WishListController"));
const GetController_1 = __importDefault(require("./Controller/GetController"));
const SettingsController_1 = __importDefault(require("./Controller/SettingsController"));
const PageController_1 = __importDefault(require("./Controller/PageController"));
const Authrization_1 = require("./middlewares/Authrization");
const ReviewsController_1 = __importDefault(require("./Controller/ReviewsController"));
const CommentController_1 = __importDefault(require("./Controller/CommentController"));
const DailyUseController_1 = __importDefault(require("./Controller/DailyUseController"));
const OrdersAdminController_1 = __importDefault(require("./Controller/OrdersAdminController"));
const AccountController_1 = __importDefault(require("./Controller/AccountController"));
const NewsAdminController_1 = __importDefault(require("./Controller/NewsAdminController"));
const app = (0, express_1.default)();
const server = http_1.default.createServer(app);
const PORT = process.env.PORT || 3030;
app.use(express_1.default.json());
// Define a custom middleware function
app.use((0, cors_1.default)());
app.use("/uploads", express_1.default.static("uploads"));
// @ts-ignore
app.use("/api", Authrization_1.auth);
// @ts-ignore
app.use("/admin", Authrization_1.authAdmin);
app.use("/admin/user", UsersAdminController_1.default.getRouter());
app.use("/admin/category", CategoriesAdminController_1.default.getRouter());
app.use("/admin/topic", TopicAdminController_1.default.getRouter());
app.use("/admin/news", NewsAdminController_1.default.getRouter());
app.use("/admin/product", ProductsAdminController_1.default.getRouter());
app.use("/", LoginController_1.default.getRouter());
app.use("/api/user", UsersController_1.default.getRouter());
app.use("/api/message", MessageController_1.default.getRouter());
app.use("/api/order", OrdersController_1.default.getRouter());
app.use("/public", PublicController_1.default.getRouter());
app.use("/api/wishlist", WishListController_1.default.getRouter());
app.use("/api/dailyuse", DailyUseController_1.default.getRouter());
app.use("/api/cart", CartController_1.default.getRouter());
app.use("/api/reviews", ReviewsController_1.default.getRouter());
app.use("/api/comments", CommentController_1.default.getRouter());
app.use("/api/get", GetController_1.default.getRouter());
app.use("/admin/settings", SettingsController_1.default.getRouter());
app.use("/admin/page", PageController_1.default.getRouter());
app.use("/admin/order", OrdersAdminController_1.default.getRouter());
app.use("/admin/account", AccountController_1.default.getRouter());
app.get("/", (req, res) => {
    res.send("we here");
});
server.listen(PORT, () => console.log("Server running on port " + PORT));
